<?php
/***************************************************************************
 *                                ezdloads.php
 *                            -------------------
 *   begin                : Tuesday, November 16, 2004
 *   copyright            : (C) 2004 HerrBawl Technologies
 *   email                : admin@herrbawl.com
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/
 
define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);

$userdata = session_pagestart($user_ip, PAGE_INDEX);
init_userprefs($userdata);

$page_title = $lang['Downloads'];
include($phpbb_root_path . 'includes/page_header.'.$phpEx);

$template->set_filenames(array(
	'body_search' => 'ezdloads_search_body.tpl',
	'body_none' => 'ezdloads_none_body.tpl',
	'body_per_page' => 'ezdloads_per_page_body.tpl',
	'body_indexed' => 'ezdloads_indexed_body.tpl')
);

function get_forums()
{
	global $db;
	$sql = 'SELECT `forum_id` , `forum_name` , `dload_check` ';
	$sql .= 'FROM `' . FORUMS_TABLE . '` ';
	
	$result = $db->sql_query($sql);
	
	$forums = array();
		
	if ($row = $db->sql_fetchrow($result))
	{
		$i = 0;
		do
		{
			$forums[$i]['id'] = $row['forum_id'];
			$forums[$i]['name'] = $row['forum_name'];
			$forums[$i]['check'] = $row['dload_check'];
			$i++;
		}
		while ($row = $db->sql_fetchrow($result));
	};
	
	return $forums;
};

function get_topics($fid)
{
	global $db;
	$sql = 'SELECT `topic_id` , `forum_id` , `topic_title` , `topic_attachment` , `topic_first_post_id` ';
	$sql .= 'FROM `' . TOPICS_TABLE . '` ';
	$sql .= 'WHERE `forum_id` = \'' . $fid . '\' ';
	
	$result = $db->sql_query($sql);
	
	$topics = array();
		
	if ($row = $db->sql_fetchrow($result))
	{
		$i = 0;
		do
		{
			$topics[$i]['id'] = $row['topic_id'];
			$topics[$i]['title'] = $row['topic_title'];
			$topics[$i]['att'] = $row['topic_attachment'];
			$topics[$i]['first'] = $row['topic_first_post_id'];
			$i++;
		}
		while ($row = $db->sql_fetchrow($result));
	};
	
	return $topics;
};

function get_posts($tid)
{
	global $db;
	$sql = 'SELECT `post_id` , `post_attachment` , `topic_id` ';
	$sql .= 'FROM `' . POSTS_TABLE . '` ';
	$sql .= 'WHERE `topic_id` = \'' . $tid . '\' ';
	
	$result = $db->sql_query($sql);
	
	$topics = array();
		
	if ($row = $db->sql_fetchrow($result))
	{
		$i = 0;
		do
		{
			$topics[$i]['id'] = $row['post_id'];
			$topics[$i]['att'] = $row['post_attachment'];
			$i++;
		}
		while ($row = $db->sql_fetchrow($result));
	};
	
	return $topics;
};

function get_attachs($pid)
{
	global $db;
	
	$sql = 'SELECT `attach_id` , `post_id` ';
	$sql .= 'FROM `' . ATTACHMENTS_TABLE . '` ';
	$sql .= 'WHERE `post_id` = \'' . $pid . '\' ';
	
	$result = $db->sql_query($sql);
	
	$aid = array();
		
	if ($row = $db->sql_fetchrow($result))
	{
		$i = 0;
		do
		{
			$aid[$i]['id'] = $row['attach_id'];
			$i++;
		}
		while ($row = $db->sql_fetchrow($result));
	};
	
	return $aid;
};

function get_attach_info($aid)
{
	global $db;
	
	$sql = 'SELECT `attach_id` , `comment` , `download_count` , `real_filename` , `filetime` ';
	$sql .= 'FROM `' . ATTACHMENTS_DESC_TABLE . '` ';
	$sql .= 'WHERE `attach_id` = \'' . $aid . '\' ';
	
	$result = $db->sql_query($sql);
	
	$myattach = $db->sql_fetchrow($result);
	
	return $myattach;
};

function get_cfg($name)
{
	global $db;
	$sql = 'SELECT `config_name` , `config_value` ';
	$sql .= 'FROM `' . CONFIG_TABLE . '` ';
	$sql .= 'WHERE `config_name` = \'' . $name . '\'';
	
	$result = $db->sql_query($sql);
	$row = $db->sql_fetchrow($result);
	return $row['config_value'];
};

function get_files($dir) 
{
    $file_list = '';
	$stack[] = $dir;
   	while ($stack)
   	{
       $current_dir = array_pop($stack);
       if ($dh = opendir($current_dir))
       {
           while (($file = readdir($dh)) !== false)
           {
               if ($file !== '.' AND $file !== '..' AND basename($file, '.htm') !== 'index' AND basename($file, '.html') !== 'index' AND basename($file, '.php') !== 'index')
               {
                   $current_file = "{$current_dir}/{$file}";
                   if (is_file($current_file))
                   {
                       $file_list[] = "{$current_dir}/{$file}";
                   }
                   elseif (is_dir($current_file))
                   {
                       $stack[] = $current_file;
                   };
               };
           };
       };
   };
   return $file_list;
};

function is_in($var, $arr)
{
	$bool = false;
	for( $o = 0; $o < count($arr); $o++ )
	{
		if( $arr[$o]['title'] == $var )
		{
			$bool = true;
		};
	};
	return $bool;
};

//Retrieve Configuration
$dload_root = get_cfg('dload_root');
$dload_folder = get_cfg('dload_folder');
$dload_dir = stripslashes(get_cfg('dload_dir'));
$dload_dir_sub = get_cfg('dload_dir_sub');
$dload_pag = get_cfg('dload_pag');
$dload_search = get_cfg('dload_search');
$dload_comm = get_cfg('dload_comm');
$dload_perpag_type = get_cfg('dload_perpag_type');
$dload_perpag_num = get_cfg('dload_perpag_num');

$allfrms = get_forums();
$myforums = array();
$n = 0;
for( $i = 0; $i < count($allfrms); $i++ )
{
	$forumset = false;
	$f = $n;
	if( $allfrms[$i]['check'] == '1' )
	{
		$alltpcs = get_topics($allfrms[$i]['id']);
		$mytopics = array();
		$nn = 0;
		for( $ii = 0; $ii < count($alltpcs); $ii++ )		
		{
			$topicset = false;
			$t = $nn;
			if( $alltpcs[$ii]['att'] == '1' )
			{
				$allpsts = get_posts($alltpcs[$ii]['id']);
				$nnnn = 0;
				for( $iii = 0; $iii < count($allpsts); $iii++ )
				{
					if( $dload_root == '0' )
					{
						if( $allpsts[$iii]['id'] == $alltpcs[$ii]['first'] )
						{
							if( $allpsts[$iii]['att'] == '1' )
							{
								if( !$forumset )
								{
									$myforums[$f]['name'] = $allfrms[$i]['name'];
									$n++;
									$forumset = true;
								};
								if( !$topicset )
								{
									$myforums[$f]['topics'][$t]['type'] = 'attach';
									$myforums[$f]['topics'][$t]['title'] = $alltpcs[$ii]['title'];
									$myforums[$f]['topics'][$t]['id'] = $alltpcs[$ii]['id'];
									$nn++;
									$topicset = true;
								};
								$allatts = get_attachs($allpsts[$iii]['id']);
								for( $iiii = 0; $iiii < count($allatts); $iiii++ )
								{
									$thisinfo = get_attach_info($allatts[$iiii]['id']);
									$myforums[$f]['topics'][$t]['attachs'][$nnnn]['id'] = $allatts[$iiii]['id'];
									$myforums[$f]['topics'][$t]['attachs'][$nnnn]['name'] = $thisinfo['real_filename'];
									$myforums[$f]['topics'][$t]['attachs'][$nnnn]['desc'] = $thisinfo['comment'];
									$myforums[$f]['topics'][$t]['attachs'][$nnnn]['dlct'] = $thisinfo['download_count'];
									$myforums[$f]['topics'][$t]['attachs'][$nnnn]['time'] = create_date($board_config['default_dateformat'], $thisinfo['filetime'], $board_config['board_timezone']);
									$myforums[$f]['topics'][$t]['attachs'][$nnnn]['link'] = append_sid('download.' . $phpEx . '?id=' . $allatts[$iiii]['id']);
									$nnnn++;
								};
							};
						};
					}
					else
					{
						if( $allpsts[$iii]['att'] == '1' )
						{
							if( !$forumset )
							{
								$myforums[$f]['name'] = $allfrms[$i]['name'];
								$n++;
								$forumset = true;
							};
							if( !$topicset )
							{
								$myforums[$f]['topics'][$t]['type'] = 'attach';
								$myforums[$f]['topics'][$t]['title'] = $alltpcs[$ii]['title'];
								$myforums[$f]['topics'][$t]['id'] = $alltpcs[$ii]['id'];
								$nn++;
								$topicset = true;
							};
							$allatts = get_attachs($allpsts[$iii]['id']);
							for( $iiii = 0; $iiii < count($allatts); $iiii++ )
							{
								$thisinfo = get_attach_info($allatts[$iiii]['id']);
								$myforums[$f]['topics'][$t]['attachs'][$nnnn]['id'] = $allatts[$iiii]['id'];
								$myforums[$f]['topics'][$t]['attachs'][$nnnn]['name'] = $thisinfo['real_filename'];
								$myforums[$f]['topics'][$t]['attachs'][$nnnn]['desc'] = $thisinfo['comment'];
								$myforums[$f]['topics'][$t]['attachs'][$nnnn]['dlct'] = $thisinfo['download_count'];
								$myforums[$f]['topics'][$t]['attachs'][$nnnn]['time'] = create_date($board_config['default_dateformat'], $thisinfo['filetime'], $board_config['board_timezone']);
								$myforums[$f]['topics'][$t]['attachs'][$nnnn]['link'] = append_sid('download.' . $phpEx . '?id=' . $allatts[$iiii]['id']);
								$nnnn++;
							};
						};
					};
				};				
			};
		};
	};
};

if( $dload_folder == '1' )
{
	$base_dir = $dload_dir;
	$myfiles = array();
	if( is_dir($base_dir) )
	{
		if( $dload_dir_sub == '0' )
		{
				if( $dh = opendir($base_dir) )
				{
       			while( ($file = readdir($dh)) !== false )
       			{
	       			if( !is_dir($file) )
					{
						$myfiles[] = $file;
					};
           		}
       			closedir($dh);
   			};
		}
		else
		{
			$myfiles = get_files($base_dir);
		};
	};
};

if( count($myfiles) > 0 )
{
	$myforums[]['name'] = $lang['Available_Attachs'];
	$f = count($myforums) - 1;
	$t = -1;
	$a = 0;
	for( $i = 0; $i < count($myfiles); $i++ )
	{
		if( count($myforums[$f]['topics']) < 1 || !is_in(dirname($myfiles[$i]), $myforums[$f]['topics']) )
		{
			$t++;
			$myforums[$f]['topics'][$t]['type'] = 'folder';
			$myforums[$f]['topics'][$t]['title'] = dirname($myfiles[$i]);
			$a = 0;
		};
		if( filesize($myfiles[$i]) < 1024 )
		{
			$size = filesize($myfiles[$i]);
			$measure = ' Bytes';						
		}
		elseif( filesize($myfiles[$i]) > 1023 && filesize($myfiles[$i]) < 1048576 )
		{
			$size = round(filesize($myfiles[$i])/1024,2);
			$measure = ' KB';
		}
		elseif( filesize($myfiles[$i]) > 1048575 && filesize($myfiles[$i]) < 1073741824 )
		{
			$size = round(filesize($myfiles[$i])/1048576,2);
			$measure = ' MB';
		}
		else
		{
			$size = round(filesize($myfiles[$i])/1073741824,2);
			$measure = ' GB';
		};
		$myforums[$f]['topics'][$t]['attachs'][$a]['id'] = '';
		$myforums[$f]['topics'][$t]['attachs'][$a]['name'] = basename($myfiles[$i]);
		$myforums[$f]['topics'][$t]['attachs'][$a]['desc'] = $size . $measure;
		$myforums[$f]['topics'][$t]['attachs'][$a]['dlct'] = '';
		$myforums[$f]['topics'][$t]['attachs'][$a]['time'] = create_date($board_config['default_dateformat'], filectime($myfiles[$i]), $board_config['board_timezone']);
		$myforums[$f]['topics'][$t]['attachs'][$a]['link'] = $myfiles[$i];
		$a++;
	};
};

if( isset($HTTP_POST_VARS['srch']) )
{
	$srch_value = htmlspecialchars($HTTP_POST_VARS['srch']);
}
else
{
	$srch_value = '';
};

$template->assign_vars(array(
	'NONE' => $lang['No_Downloads'],
	'SEARCH' => '<form action="ezdloads.php?search=true" name="search_form" method="post"><br /><DIV align="center" class="genmed"><b>' . $lang['Download_Search_Explain'] . '</b> <input type="text" maxlength=30 size=30 name="srch" value="' . $srch_value . '"> <input type="submit" value="' . $lang['Download_Search'] . '" class="mainoption"></DIV></form><br />',
	'CAT_FLNAM' => $lang['File_Name'],
	'CAT_FSIZE' => $lang['File_Size'],
	'CAT_FDESC' => $lang['File_Description'],
	'CAT_FDATE' => $lang['Uploaded_On'],
	'CAT_DLCNT' => $lang['Download_Count'],
	'CAT_FCOMM' => $lang['View_File_Comments'],
	'CAT_FCADD' => $lang['Add_File_Comments'])
);

$none = true;

if( !isset($HTTP_GET_VARS['search']) )
{
	switch( $dload_pag )
	{
		case "0":
			if( !count($myforums) < 1 )
			{
				if( $dload_search == '1' )
				{
					$template->assign_block_vars('download_search', array());
				};
				for( $i = 0; $i < count($myforums); $i++ )
				{
					$template->assign_block_vars('download_cat', array(
						'NAME' => $myforums[$i]['name'])
					);
					for( $ii = 0; $ii < count($myforums[$i]['topics']); $ii++ )
					{
						$template->assign_block_vars('download_cat.sub', array(
							'TITLE' => $myforums[$i]['topics'][$ii]['title'],
							'U_VIEW_COMMENTS' => append_sid('viewtopic.' . $phpEx . '?t=' . $myforums[$i]['topics'][$ii]['id']))
						);
						if ( ($userdata['session_logged_in'] && $myforums[$i]['topics'][$ii]['type'] == 'attach') || ($dload_comm == '0' && $myforums[$i]['topics'][$ii]['type'] == 'attach') )
						{
							$template->assign_block_vars('download_cat.sub.LOGGEDIN', array());
						};
						if ( $myforums[$i]['topics'][$ii]['type'] == 'attach' )
						{
							$template->assign_block_vars('download_cat.sub.SHOW_COUNT', array());
						}
						else
						{
							$template->assign_block_vars('download_cat.sub.SHOW_SIZE', array());
						};
						for( $iii = 0; $iii < count($myforums[$i]['topics'][$ii]['attachs']); $iii++ )
						{
							$template->assign_block_vars('download_cat.sub.DLs', array(
								'NAME' => $myforums[$i]['topics'][$ii]['attachs'][$iii]['name'],
								'DESC' => $myforums[$i]['topics'][$ii]['attachs'][$iii]['desc'],
								'DLCT' => $myforums[$i]['topics'][$ii]['attachs'][$iii]['dlct'],
								'TIME' => $myforums[$i]['topics'][$ii]['attachs'][$iii]['time'],
								'LINK' => $myforums[$i]['topics'][$ii]['attachs'][$iii]['link'])
							);
							if ( ($userdata['session_logged_in'] && $myforums[$i]['topics'][$ii]['type'] == 'attach') || ($dload_comm == '0' && $myforums[$i]['topics'][$ii]['type'] == 'attach') ) 
							{
								if (count($myforums[$i]['topics'][$ii]['attachs']) > 0)
								{
									$template->assign_block_vars('download_cat.sub.DLs.LOGGEDIN', array());
								};
							};
							if ( $myforums[$i]['topics'][$ii]['type'] == 'attach' )
							{
								$template->assign_block_vars('download_cat.sub.DLs.SHOW_COUNT', array());
							}
							else
							{
								$template->assign_block_vars('download_cat.sub.DLs.SHOW_SIZE', array());
							};
						};
						$none = false;
					};
				};
			};
			if( $none )
			{
				$template->assign_block_vars('download_none', array());
			};
			$template->pparse('body_none');
			break;
		case "1":
			$p_cnt = 1;
			$p = 0;
			$ff = -1;				
			for( $f = 0; $f < count($myforums); $f++ )
			{
				$forumset = false;
				$topicset = false;
				$tt = -1;
				if( $dload_perpag_type == '0' )
				{
					if( $p_cnt != $dload_perpag_num )
					{
						$page[$p]['forums'][] = $myforums[$f];
						$p_cnt++;
					}
					else
					{
						$page[$p]['forums'][] = $myforums[$f];
						$p_cnt = 1;
						$p++;
					};
				}
				else
				{
					for( $t = 0; $t < count($myforums[$f]['topics']); $t++ )
					{
						$topicset = false;				
						if( $dload_perpag_type == '1' )
						{
							if( !$forumset )
							{
								$forumset = true;
								$ff++;
								$page[$p]['forums'][$ff]['name'] = $myforums[$f]['name'];
							};
							if( $p_cnt != $dload_perpag_num )
							{
								$page[$p]['forums'][$ff]['topics'][] = $myforums[$f]['topics'][$t];
								$p_cnt++;
							}
							else
							{
								$page[$p]['forums'][$ff]['topics'][] = $myforums[$f]['topics'][$t];
								$p_cnt = 1;
								$p++;
								$ff = -1;
								$forumset = false;								
							};
						}
						else
						{
							for( $a = 0; $a < count($myforums[$f]['topics'][$t]['attachs']); $a++ )
							{
								if( !$forumset )
								{
									$forumset = true;
									$ff++;
									$page[$p]['forums'][$ff]['name'] = $myforums[$f]['name'];
								};
								if( !$topicset )
								{
									$topicset = true;
									$tt++;
									$page[$p]['forums'][$ff]['topics'][$tt]['type'] = $myforums[$f]['topics'][$t]['type'];
									$page[$p]['forums'][$ff]['topics'][$tt]['title'] = $myforums[$f]['topics'][$t]['title'];
								};
								if( $p_cnt != $dload_perpag_num )
								{
									$page[$p]['forums'][$ff]['topics'][$tt]['attachs'][] = $myforums[$f]['topics'][$t]['attachs'][$a];
									$p_cnt++;
								}
								else
								{
									$page[$p]['forums'][$ff]['topics'][$tt]['attachs'][] = $myforums[$f]['topics'][$t]['attachs'][$a];
									$p_cnt = 1;
									$p++;
									$forumset = false;
									$topicset = false;
									$ff = -1;
									$tt = -1;
								};
							};
						};
					};
				};
			};
			if( isset($HTTP_GET_VARS['p']) )
			{
				$p_num = intval($HTTP_GET_VARS['p']);
				if( $p_num <= count($page) && $p_num > 0 )
				{
					$cur_page = $p_num;
				}
				else
				{
					$cur_page = 1;
				};
			}
			else
			{
				$cur_page = 1;
			};
			if( $cur_page > 1 )
			{
				$template->assign_block_vars('download_pag', array(
					'LINK' => '<a href="ezdloads.php?p=' . ($cur_page - 1) . '" class="nav">' . $lang['DL_Previous'] . '</a>')
				);
			};
			if( count($page) > 2 )
			{
				for( $pp = 0; $pp < count($page); $pp++ )
				{
					if( ($cur_page - 1) !== $pp )
					{
						$template->assign_block_vars('download_pag', array(
							'LINK' => '<a href="ezdloads.php?p=' . ($pp + 1) . '" class="nav">' . ($pp + 1) . '</a>')
						);
					}
					else
					{
						$template->assign_block_vars('download_pag', array(
							'LINK' => ($pp + 1))
						);
					};
				};
			};
			if( ($cur_page + 1) <= count($page) )
			{
				$template->assign_block_vars('download_pag', array(
					'LINK' => '<a href="ezdloads.php?p=' . ($cur_page + 1) . '" class="nav">' . $lang['DL_Next'] . '</a>')
				);
			};
			if( !count($page[$cur_page - 1]['forums']) < 1 )
			{
				if( $dload_search == '1' )
				{
					$template->assign_block_vars('download_search', array());
				};
				for( $i = 0; $i < count($page[$cur_page - 1]['forums']); $i++ )
				{
					$template->assign_block_vars('download_cat', array(
						'NAME' => $page[$cur_page - 1]['forums'][$i]['name'])
					);
					for( $ii = 0; $ii < count($page[$cur_page - 1]['forums'][$i]['topics']); $ii++ )
					{
						$template->assign_block_vars('download_cat.sub', array(
							'TITLE' => $page[$cur_page - 1]['forums'][$i]['topics'][$ii]['title'],
							'U_VIEW_COMMENTS' => append_sid('viewtopic.' . $phpEx . '?t=' . $page[$cur_page - 1]['forums'][$i]['topics'][$ii]['id']))
						);
						if ( ($userdata['session_logged_in'] && $page[$cur_page - 1]['forums'][$i]['topics'][$ii]['type'] == 'attach') || ($dload_comm == '0' && $page[$cur_page - 1]['forums'][$i]['topics'][$ii]['type'] == 'attach') )
						{
							$template->assign_block_vars('download_cat.sub.LOGGEDIN', array());
						};
						if ( $page[$cur_page - 1]['forums'][$i]['topics'][$ii]['type'] == 'attach' )
						{
							$template->assign_block_vars('download_cat.sub.SHOW_COUNT', array());
						}
						else
						{
							$template->assign_block_vars('download_cat.sub.SHOW_SIZE', array());
						};
						for( $iii = 0; $iii < count($page[$cur_page - 1]['forums'][$i]['topics'][$ii]['attachs']); $iii++ )
						{
							$template->assign_block_vars('download_cat.sub.DLs', array(
								'NAME' => $page[$cur_page - 1]['forums'][$i]['topics'][$ii]['attachs'][$iii]['name'],
								'DESC' => $page[$cur_page - 1]['forums'][$i]['topics'][$ii]['attachs'][$iii]['desc'],
								'DLCT' => $page[$cur_page - 1]['forums'][$i]['topics'][$ii]['attachs'][$iii]['dlct'],
								'TIME' => $page[$cur_page - 1]['forums'][$i]['topics'][$ii]['attachs'][$iii]['time'],
								'LINK' => $page[$cur_page - 1]['forums'][$i]['topics'][$ii]['attachs'][$iii]['link'])
							);
							if ( ($userdata['session_logged_in'] && $page[$cur_page - 1]['forums'][$i]['topics'][$ii]['type'] == 'attach') || ($dload_comm == '0' && $page[$cur_page - 1]['forums'][$i]['topics'][$ii]['type'] == 'attach') ) 
							{
								if (count($page[$cur_page - 1]['forums'][$i]['topics'][$ii]['attachs']) > 0)
								{
									$template->assign_block_vars('download_cat.sub.DLs.LOGGEDIN', array());
								};
							};
							if ( $page[$cur_page - 1]['forums'][$i]['topics'][$ii]['type'] == 'attach' )
							{
								$template->assign_block_vars('download_cat.sub.DLs.SHOW_COUNT', array());
							}
							else
							{
								$template->assign_block_vars('download_cat.sub.DLs.SHOW_SIZE', array());
							};
						};
						$none = false;
					};
				};
			};
			if( $none )
			{
				$template->assign_block_vars('download_none', array());
			};
			$template->pparse('body_per_page');
			break;
		case "2":
			if( !isset($HTTP_GET_VARS['f']) && !isset($HTTP_GET_VARS['t']) )
			{
				for( $f = 0; $f < count($myforums); $f++ )
				{
					$template->assign_block_vars('download_f', array(
						'NAME' => $myforums[$f]['name'],
						'ID' => $f)
					);
					$col = 1;
					for( $t = 0; $t < count($myforums[$f]['topics']); $t++ )
					{
						if( $col == 1 )
						{
							$template->assign_block_vars('download_f.t_row', array());
						};
						$template->assign_block_vars('download_f.t_row.t_col', array(
							'TITLE' => $myforums[$f]['topics'][$t]['title'],
							'ID' => $t)
						);
						if( $col == 4 )
						{
							$col = 1;
						}
						else
						{
							$col++;
						};
					};
					$none = false;
				};
			}
			elseif( isset($HTTP_GET_VARS['f']) && isset($HTTP_GET_VARS['t']) )
			{
				$cur_f = 0;
				$cur_t = 0;
				$f_num = intval($HTTP_GET_VARS['f']);
				$t_num = intval($HTTP_GET_VARS['t']);
				if( $f_num <= count($myforums) && $f_num > 0 )
				{
					$cur_f = $f_num;
					if( $t_num <= count($myforums[$cur_f]['topics']) && $t_num > 0 )
					{
						$cur_t = $t_num;
					};
				};
				$template->assign_block_vars('download_cat', array(
					'NAME' => $myforums[$cur_f]['name'])
				);
				$template->assign_block_vars('download_cat.sub', array(
					'TITLE' => $myforums[$cur_f]['topics'][$cur_t]['title'],
					'U_VIEW_COMMENTS' => append_sid('viewtopic.' . $phpEx . '?t=' . $myforums[$cur_f]['topics'][$cur_t]['id']))
				);
				if ( ($userdata['session_logged_in'] && $myforums[$cur_f]['topics'][$cur_t]['type'] == 'attach') || ($dload_comm == '0' && $myforums[$cur_f]['topics'][$cur_t]['type'] == 'attach') )
				{
					$template->assign_block_vars('download_cat.sub.LOGGEDIN', array());
				};
				if ( $myforums[$cur_f]['topics'][$cur_t]['type'] == 'attach' )
				{
					$template->assign_block_vars('download_cat.sub.SHOW_COUNT', array());
				}
				else
				{
					$template->assign_block_vars('download_cat.sub.SHOW_SIZE', array());
				};
				for( $iii = 0; $iii < count($myforums[$cur_f]['topics'][$cur_t]['attachs']); $iii++ )
				{
					$template->assign_block_vars('download_cat.sub.DLs', array(
						'NAME' => $myforums[$cur_f]['topics'][$cur_t]['attachs'][$iii]['name'],
						'DESC' => $myforums[$cur_f]['topics'][$cur_t]['attachs'][$iii]['desc'],
						'DLCT' => $myforums[$cur_f]['topics'][$cur_t]['attachs'][$iii]['dlct'],
						'TIME' => $myforums[$cur_f]['topics'][$cur_t]['attachs'][$iii]['time'],
						'LINK' => $myforums[$cur_f]['topics'][$cur_t]['attachs'][$iii]['link'])
					);
					if ( ($userdata['session_logged_in'] && $myforums[$cur_f]['topics'][$cur_t]['type'] == 'attach') || (dload_comm == '0' && $myforums[$cur_f]['topics'][$cur_t]['type'] == 'attach') ) 
					{
						if (count($myforums[$cur_f]['topics'][$cur_t]['attachs']) > 0)
						{
							$template->assign_block_vars('download_cat.sub.DLs.LOGGEDIN', array());
						};
					};
					if ( $myforums[$cur_f]['topics'][$cur_t]['type'] == 'attach' )
					{
						$template->assign_block_vars('download_cat.sub.DLs.SHOW_COUNT', array());
					}
					else
					{
						$template->assign_block_vars('download_cat.sub.DLs.SHOW_SIZE', array());
					};
				};
				$none = false;
			}
			elseif( isset($HTTP_GET_VARS['f']) )
			{
				$cur_f = 0;
				$f_num = intval($HTTP_GET_VARS['f']);
				if( $f_num <= count($myforums) && $f_num > 0 )
				{
					$cur_f = $f_num;
				};
				$template->assign_block_vars('download_cat', array(
					'NAME' => $myforums[$cur_f]['name'])
				);
				for( $ii = 0; $ii < count($myforums[$cur_f]['topics']); $ii++ )
				{
					$template->assign_block_vars('download_cat.sub', array(
						'TITLE' => $myforums[$cur_f]['topics'][$ii]['title'],
						'U_VIEW_COMMENTS' => append_sid('viewtopic.' . $phpEx . '?t=' . $myforums[$cur_f]['topics'][$ii]['id']))
					);
					if ( ($userdata['session_logged_in'] && $myforums[$cur_f]['topics'][$ii]['type'] == 'attach') || (dload_comm == '0' && $myforums[$cur_f]['topics'][$ii]['type'] == 'attach') )
					{
						$template->assign_block_vars('download_cat.sub.LOGGEDIN', array());
					};
					if ( $myforums[$cur_f]['topics'][$ii]['type'] == 'attach' )
					{
						$template->assign_block_vars('download_cat.sub.SHOW_COUNT', array());
					}
					else
					{
						$template->assign_block_vars('download_cat.sub.SHOW_SIZE', array());
					};
					for( $iii = 0; $iii < count($myforums[$cur_f]['topics'][$ii]['attachs']); $iii++ )
					{
						$template->assign_block_vars('download_cat.sub.DLs', array(
							'NAME' => $myforums[$cur_f]['topics'][$ii]['attachs'][$iii]['name'],
							'DESC' => $myforums[$cur_f]['topics'][$ii]['attachs'][$iii]['desc'],
							'DLCT' => $myforums[$cur_f]['topics'][$ii]['attachs'][$iii]['dlct'],
							'TIME' => $myforums[$cur_f]['topics'][$ii]['attachs'][$iii]['time'],
							'LINK' => $myforums[$cur_f]['topics'][$ii]['attachs'][$iii]['link'])
						);
						if ( ($userdata['session_logged_in'] && $myforums[$cur_f]['topics'][$ii]['type'] == 'attach') || (dload_comm == '0' && $myforums[$cur_f]['topics'][$ii]['type'] == 'attach') ) 
						{
							if (count($myforums[$cur_f]['topics'][$ii]['attachs']) > 0)
							{
								$template->assign_block_vars('download_cat.sub.DLs.LOGGEDIN', array());
							};
						};
						if ( $myforums[$cur_f]['topics'][$ii]['type'] == 'attach' )
						{
							$template->assign_block_vars('download_cat.sub.DLs.SHOW_COUNT', array());
						}
						else
						{
							$template->assign_block_vars('download_cat.sub.DLs.SHOW_SIZE', array());
						};
					};
					$none = false;
				};
			};
			if( $dload_search == '1' )
			{
				$template->assign_block_vars('download_search', array());
			};
			if( $none )
			{
				$template->assign_block_vars('download_none', array());
			};
			$template->pparse('body_indexed');
			break;
	};
}
else
{
	if( $dload_search == '1' )
	{
		$searchset = false;
		$attachset = false;
		$folderset = false;
		for( $f = 0; $f < count($myforums); $f++ )
		{
			for( $t = 0; $t < count($myforums[$f]['topics']); $t++ )
			{
				for( $a = 0; $a < count($myforums[$f]['topics'][$t]['attachs']); $a++ )
				{
					if( substr_count(strtolower($myforums[$f]['topics'][$t]['attachs'][$a]['name']), strtolower($HTTP_POST_VARS['srch'])) > 0 )
					{
						if( !$searchset )
						{
							$mysearch[0]['name'] = $lang['Download_Search_Result'] . $HTTP_POST_VARS['srch'];
							$searchset = true;
						};
						switch( $myforums[$f]['topics'][$t]['type'] )
						{
							case 'attach':
								if( !$attachset )
								{
									$mysearch[0]['topics'][]['type'] = 'attach';
									for( $ss = 0; $ss < count($mysearch[0]['topics']); $ss++ )
									{
										if( $mysearch[0]['topics'][$ss]['type'] == 'attach' )
										{
											$tt = $ss;
										};
									};
									$mysearch[0]['topics'][$tt]['title'] = $lang['Download_Search_Att'];
									$attachset = true;
								};
								for( $ss = 0; $ss < count($mysearch[0]['topics']); $ss++ )
								{
									if( $mysearch[0]['topics'][$ss]['type'] == 'attach' )
									{
										$tt = $ss;
									};
								};
								$mysearch[0]['topics'][$tt]['attachs'][] = $myforums[$f]['topics'][$t]['attachs'][$a];
								break;
							case 'folder':
								if( !$folderset )
								{
									$mysearch[0]['topics'][]['type'] = 'folder';
									for( $ss = 0; $ss < count($mysearch[0]['topics']); $ss++ )
									{
										if( $mysearch[0]['topics'][$ss]['type'] == 'folder' )
										{
											$tt = $ss;
										};
									};
									$mysearch[0]['topics'][$tt]['title'] = $lang['Download_Search_Fld'];
									$folderset = true;
								};
								for( $ss = 0; $ss < count($mysearch[0]['topics']); $ss++ )
								{
									if( $mysearch[0]['topics'][$ss]['type'] == 'folder' )
									{
										$tt = $ss;
									};
								};
								$mysearch[0]['topics'][$tt]['attachs'][] = $myforums[$f]['topics'][$t]['attachs'][$a];
								break;
						};
					};
				};
			};
		};
		if( $dload_search == '1' )
		{
			$template->assign_block_vars('download_search', array());
		};
		for( $i = 0; $i < count($mysearch); $i++ )
		{
			$template->assign_block_vars('download_cat', array(
				'NAME' => $mysearch[$i]['name'])
			);
			for( $ii = 0; $ii < count($mysearch[$i]['topics']); $ii++ )
			{
				$template->assign_block_vars('download_cat.sub', array(
					'TITLE' => $mysearch[$i]['topics'][$ii]['title'],
					'U_VIEW_COMMENTS' => append_sid('viewtopic.' . $phpEx . '?t=' . $mysearch[$i]['topics'][$ii]['id']))
				);
				if ( ($userdata['session_logged_in'] && $mysearch[$i]['topics'][$ii]['type'] == 'attach') || ($dload_comm == '0' && $mysearch[$i]['topics'][$ii]['type'] == 'attach') )
				{
					$template->assign_block_vars('download_cat.sub.LOGGEDIN', array());
				};
				if ( $mysearch[$i]['topics'][$ii]['type'] == 'attach' )
				{
					$template->assign_block_vars('download_cat.sub.SHOW_COUNT', array());
				}
				else
				{
					$template->assign_block_vars('download_cat.sub.SHOW_SIZE', array());
				};
				for( $iii = 0; $iii < count($mysearch[$i]['topics'][$ii]['attachs']); $iii++ )
				{
					$template->assign_block_vars('download_cat.sub.DLs', array(
						'NAME' => $mysearch[$i]['topics'][$ii]['attachs'][$iii]['name'],
						'DESC' => $mysearch[$i]['topics'][$ii]['attachs'][$iii]['desc'],
						'DLCT' => $mysearch[$i]['topics'][$ii]['attachs'][$iii]['dlct'],
						'TIME' => $mysearch[$i]['topics'][$ii]['attachs'][$iii]['time'],
						'LINK' => $mysearch[$i]['topics'][$ii]['attachs'][$iii]['link'])
					);
					if ( ($userdata['session_logged_in'] && $mysearch[$i]['topics'][$ii]['type'] == 'attach') || ($dload_comm == '0' && $mysearch[$i]['topics'][$ii]['type'] == 'attach') ) 
					{
						if (count($mysearch[$i]['topics'][$ii]['attachs']) > 0)
						{
							$template->assign_block_vars('download_cat.sub.DLs.LOGGEDIN', array());
						};
					};
					if ( $mysearch[$i]['topics'][$ii]['type'] == 'attach' )
					{
						$template->assign_block_vars('download_cat.sub.DLs.SHOW_COUNT', array());
					}
					else
					{
						$template->assign_block_vars('download_cat.sub.DLs.SHOW_SIZE', array());
					};
				};
				$none = false;
			};
		};
		if( $none )
		{
			$template->assign_block_vars('download_none', array());
		};
		$template->pparse('body_search');
	}
	else
	{
		echo "<HTML><HEAD>";
		echo "<META HTTP-EQUIV=\"refresh\" content=\"0;URL=" . append_sid("ezdloads." . $phpEx) . "\">";
		echo "</HEAD><BODY><h1></h1></BODY></HTML>";
	};
};

include($phpbb_root_path . 'includes/page_tail.'.$phpEx);

?>